import gulp from 'gulp';
import browser from 'browser-sync';
import webpack from 'webpack';

import webpackDevMiddleware from 'webpack-dev-middleware';

import webpackHotMiddleware from 'webpack-hot-middleware';

import { config } from './webpack';

import conf from './conf';

// import { serveHTML } from './serve-html';

// import { servePHP } from './serve-php';

// import { serveImages } from './serve-images';

// import { serveOur, serveRoot } from './serve-source';

import { serveCoreCSS } from './serve-css--core';

import { serveMainCSS } from './serve-css--main';

const bs = browser.create();

const bundler = webpack(config);

// import modRewrite from 'connect-modrewrite';

export function server () {
    bs.init({
        // server: 'wp-content/themes/${conf.name}/',
        proxy: 'https://dev.biuro.lt',
        // httpModule: 'http2',
        https: {
            key: 'certs/biuro.lt/privkey.pem',
            cert: 'certs/biuro.lt/certificate.pem'
        },
        files: [
            `wp-content/themes/${conf.name}/**/*.php`,
            `wp-content/themes/${conf.name}/css/main.min.css`
        ],
        open: false,
        port: 2000,
        ui: false,
        middleware: [
            webpackDevMiddleware(bundler, { /* options */ }),
            webpackHotMiddleware(bundler)
            // modRewrite([
            //   '^[^\\.]*$ /index.html [L]',
            //   // '^/wp-json/our-wp-api/v1/(.*)$ https://town.biuro.lt/wp-json/our-wp-api/v1/$1 [P]',
            //   // '^http://town.loc.al/wp-content/uploads/2018/03/(.*)$ https://town.biuro.lt/wp-content/uploads/2018/03/$1 [P]',
            // ]),
        ]
    });

    // gulp.watch('./i/**/*.*', { usePolling: true }, gulp.series(serveImages));

    // gulp.watch(['./source/biuro/**/*.*', './source/root/**/*.*'], { usePolling: true }, gulp.series(serveOur, serveRoot));

    // gulp.watch('./php/**/*.php', { usePolling: true }, gulp.series(servePHP));

    // // gulp.watch(['./*.html', './source/**/*.*', '!./source/biuro/**/*.*', '!./source/root/**/*.*', '../wp-content/themes/biuro/css/core.min.css'], gulp.series(serveHTML));

    gulp.watch([`wp-content/themes/${conf.name}/css/**/*.css`, `!wp-content/themes/${conf.name}/css/**/*.min.css`], gulp.parallel(serveCoreCSS, serveMainCSS));

    gulp.watch(`wp-content/themes/${conf.name}/css/core.min.css`).on('change', () => bs.reload());

    gulp.watch(`wp-content/themes/${conf.name}/js/*.js`).on('change', () => browser.reload());
}
